## zfs-fuse 0.6.0

=== src/SConstruct ===
import os, sys, re

# Accepted parameters (and defaults):
#
#   install_dir=/usr/local/sbin - directory where the install target copies the binaries
#   debug=1 - compilation style: 0 = optimize and strip, 1 = optimize with debug info, 2 = debug info, 3 = instrument functions

install_dir = ARGUMENTS.get('install_dir', '/usr/local/sbin')

env = Environment()

env['CC'] = 'gcc'
env['LINKFLAGS'] = Split('-pipe -Wall')
env['CCFLAGS'] = Split('-pipe -Wall -std=c99 -Wno-switch -Wno-unused -Wno-missing-braces -Wno-parentheses -Wno-uninitialized -fno-strict-aliasing -D_GNU_SOURCE -D_FILE_OFFSET_BITS=64 -D_REENTRANT -DTEXT_DOMAIN=\\"zfs-fuse\\" -DLINUX_AIO')

debug = int(ARGUMENTS.get('debug', '1'))

if not debug:
	env.Append(LINKFLAGS = ['-s'])
	env.Append(CCFLAGS = Split('-s -O2 -DNDEBUG'))
else:
	env.Append(LINKFLAGS = ['-ggdb'])
	env.Append(CCFLAGS = ['-ggdb'])
	if debug == 1:
		env.Append(CCFLAGS = ['-O2'])
	elif debug == 2:
		env.Append(CCFLAGS = ['-DDEBUG'])
	elif debug == 3:
		env.Append(CCFLAGS = Split('-finstrument-functions -DDEBUG'))

env['CPPPATH'] = []

f = os.popen('uname -m')
arch = f.readline().strip()
f.close()

def getarch(arch):
	if arch == 'sparc64':
		return 'sparc64'

	if arch == 'x86_64':
		return 'amd64'

	if re.compile('i\d86').match(arch):
		return 'i386'

	return None

myarch = getarch(arch)

if not myarch:
	print
	print 'Sorry, only the x86, amd64 and sparc64 hardware architectures are supported'
	sys.exit(1)

if myarch == 'sparc64':
	env.Append(CCFLAGS = '-mcpu=ultrasparc')
	env.Append(ASFLAGS = '-mcpu=ultrasparc')

env['ARCH'] = ARGUMENTS.get('target', myarch)

if env['ARCH'] == 'i386' and myarch == 'amd64':
	env.Append(CCFLAGS = '-m32')
	env.Append(ASFLAGS = '-m32')
	env.Append(LINKFLAGS = '-m32')

Export('env')

SConscript('lib/libavl/SConscript')
SConscript('lib/libsolcompat/SConscript')
SConscript('lib/libnvpair/SConscript')
SConscript('lib/libumem/SConscript')
SConscript('lib/libuutil/SConscript')
SConscript('lib/libzfs/SConscript')
SConscript('lib/libzfscommon/SConscript')
SConscript('lib/libzpool/SConscript')
SConscript('lib/libsolkerncompat/SConscript')
SConscript('cmd/zdb/SConscript')
SConscript('cmd/ztest/SConscript')
SConscript('cmd/zpool/SConscript')
SConscript('cmd/zfs/SConscript')
SConscript('zfs-fuse/SConscript')

env.Install(install_dir, 'cmd/zdb/zdb')
env.Install(install_dir, 'cmd/ztest/ztest')
env.Install(install_dir, 'cmd/zpool/zpool')
env.Install(install_dir, 'cmd/zfs/zfs')
env.Install(install_dir, 'zfs-fuse/zfs-fuse')

env.Alias('install', install_dir)

## zfs-fuse 0.6.9

=== wscript ===
#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
# WAF build script - this file is part of ZFS-Fuse, a port of the Solaris ZFS to Linux
#
#  Sandeep S Srinivasa <sandys(at)gmail(dot)com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# $Id$

"""
This is a WAF build script (http://code.google.com/p/waf/).
It can be used as an alternative build system to autotools
for zfs-fuse. 
"""


import Build, Configure, Options, Runner, Task, Utils
import sys, os, subprocess, shutil
from distutils import version
from Logs import error, debug, warn



APPNAME = 'zfs-fuse'
VERSION = '0.6.9'

srcdir = '.'
blddir = '__build'

subdirs = """
            src/lib/libsolcompat/
            src/lib/libumem/
            src/lib/libavl/
            src/lib/libsolkerncompat/
            src/lib/libnvpair/
            src/lib/libuutil/
            src/lib/libzpool/
            src/lib/libzfs/
            src/lib/libzfscommon/
            src/zfs-fuse/
            src/cmd/zfs/
            src/cmd/zpool/
            src/cmd/zstreamdump/
            src/cmd/zdb/
            src/cmd/ztest/
          """.split()


#####
#Cmd Line Options
####
def set_options(opt):
    opt.add_option('--prefix', type='string',help='set install path prefix', dest='usr_prefix')


def init(ctx):
    import Configure
#    Configure.configure.define('_FILE_OFFSET_BITS', 64)
####
#Configuration
####
def configure(conf):
#    import Options # getting the user-provided options to the configuration section
#    if Options.options.usr_prefix
#        Options.prefix = Options.options.usr_prefix


    conf.check_tool('gcc glib2')


#    conf.env.CCFLAGS = ['-Wall']
    conf.env.CCFLAGS = ['-pipe', '-Wall', '-std=c99', '-Wno-switch', '-Wno-unused', '-Wno-missing-braces', '-Wno-parentheses', '-Wno-uninitialized', '-fno-strict-aliasing', '-D_GNU_SOURCE', '-DLINUX_AIO']
    conf.env.INCLUDEDIR = ['/usr/include/']
#    conf.env['INCLUDEDIR'] = '/usr/include'
#    conf.define('_FILE_OFFSET_BITS', 64) 
#    conf.write_config_header('config.h')

    conf.check(header_name="aio.h", uselib_store='aio_defines', mandatory=True)
    conf.check(lib='aio',  uselib_store='aio_lib', mandatory=True)
    conf.check(lib='ssl',  uselib_store='openssl', mandatory=True)
    conf.check(lib='crypto',  uselib_store='crypto', mandatory=True)
    conf.check(lib='pthread',  uselib_store='pthread_lib', mandatory=True)
    conf.check_cc(lib='fuse',  uselib_store='fuse_lib',  mandatory=True)
    conf.check_cc(lib='dl',  uselib_store='dl_lib',  mandatory=True)
    conf.check_cc(lib='z',  uselib_store='z_lib',  mandatory=True)
    conf.check_cc(lib='m',  uselib_store='m_lib',  mandatory=True)
    conf.check_cc(header_name='fuse/fuse_lowlevel.h', includes=['/usr/include/'], 
            ccflags='-D_FILE_OFFSET_BITS=64', uselib_store='fuse_defines', mandatory=True)
#    conf.check_cc(header_name='attr/xattr.h', includes=['/usr/include/'], mandatory=True) # FIXME not working properly
    conf.check_cc(lib='rt', uselib_store='rt_lib', mandatory=True)
    conf.check_tool('gas')
    #if not conf.env.AS: conf.env.AS = conf.env.CC
    conf.env.AS = conf.env.CC

#    try:
#		conf.check_cc(compile_filename='test.s', fragment='''
#.text
#.align 2
#
#val:
# .long 10
#
## Multiply input value by 10...
#.global mult10
#.type mult10, function
#mult10:
#  movl val,%eax
#  imul 4(%esp),%eax
#  ret
#	''', type='cstaticlib', mandatory=True, msg='Checking for assembler')
#    except:
#		conf.env.AS = None

    ###################### install configuration ################

    conf.check_tool('gnu_dirs')
    warn(" setting MANDIR = %s" % conf.env.MANDIR)
    conf.env.PREFIX = '/'
    conf.env.MANDIR = '/usr/share/man/man8'


####
#Build
####
def build(bld):
    bld.add_subdirs(subdirs)
    bld.includes = '/usr/include/'
    #man_list = bld.path.ant_glob('doc/*.gz')
    bld.install_files('${MANDIR}', 'doc/*.gz')

=== src/SConstruct ===
--- 
+++ 
@@ -6,14 +6,24 @@
 #   debug=1 - compilation style: 0 = optimize and strip, 1 = optimize with debug info, 2 = debug info, 3 = instrument functions
 
 install_dir = ARGUMENTS.get('install_dir', '/usr/local/sbin')
+man_dir = ARGUMENTS.get('man_dir', '/usr/local/share/man/man8/')
+cfg_dir = ARGUMENTS.get('cfg_dir', '/etc/zfs')
 
 env = Environment()
 
+f = os.popen('uname')
+osname = f.readline().strip()
+f.close()
+
+env.CacheDir('/tmp/.zfs-fuse.scons')
 env['CC'] = 'gcc'
 env['LINKFLAGS'] = Split('-pipe -Wall')
-env['CCFLAGS'] = Split('-pipe -Wall -std=c99 -Wno-switch -Wno-unused -Wno-missing-braces -Wno-parentheses -Wno-uninitialized -fno-strict-aliasing -D_GNU_SOURCE -D_FILE_OFFSET_BITS=64 -D_REENTRANT -DTEXT_DOMAIN=\\"zfs-fuse\\" -DLINUX_AIO')
+env['CCFLAGS'] = Split('-pipe -Wall -std=c99 -Wno-switch -Wno-unused -Wno-missing-braces -Wno-parentheses -Wno-uninitialized -fno-strict-aliasing -D_GNU_SOURCE -D_FILE_OFFSET_BITS=64 -D_REENTRANT -DTEXT_DOMAIN=\\"zfs-fuse\\" ')
 
-debug = int(ARGUMENTS.get('debug', '1'))
+if osname == "Linux":
+  env.Append(CPPFLAGS = " -DLINUX_AIO")
+
+debug = int(ARGUMENTS.get('debug', '0'))
 
 if not debug:
 	env.Append(LINKFLAGS = ['-s'])
@@ -21,8 +31,9 @@
 else:
 	env.Append(LINKFLAGS = ['-ggdb'])
 	env.Append(CCFLAGS = ['-ggdb'])
+# Be careful here, one of DEBUG or NDEBUG must be defined, if you undef both, you'll get unexpected results
 	if debug == 1:
-		env.Append(CCFLAGS = ['-O2'])
+		env.Append(CCFLAGS = Split('-O2 -DDEBUG'))
 	elif debug == 2:
 		env.Append(CCFLAGS = ['-DDEBUG'])
 	elif debug == 3:
@@ -44,7 +55,7 @@
 	if re.compile('i\d86').match(arch):
 		return 'i386'
 
-	return None
+	return 'generic'
 
 myarch = getarch(arch)
 
@@ -78,6 +89,7 @@
 SConscript('cmd/zdb/SConscript')
 SConscript('cmd/ztest/SConscript')
 SConscript('cmd/zpool/SConscript')
+SConscript('cmd/zstreamdump/SConscript')
 SConscript('cmd/zfs/SConscript')
 SConscript('zfs-fuse/SConscript')
 
@@ -86,5 +98,16 @@
 env.Install(install_dir, 'cmd/zpool/zpool')
 env.Install(install_dir, 'cmd/zfs/zfs')
 env.Install(install_dir, 'zfs-fuse/zfs-fuse')
+env.Install(install_dir, 'cmd/zstreamdump/zstreamdump')
+env.Install(cfg_dir, '../contrib/zfs_pool_alert')
 
-env.Alias('install', install_dir)
+env.Install(man_dir, '../doc/zdb.8.gz')
+env.Install(man_dir, '../doc/zfs.8.gz')
+env.Install(man_dir, '../doc/zpool.8.gz')
+env.Install(man_dir, '../doc/zstreamdump.8.gz')
+
+if "tags" in sys.argv:
+    print "updating tags..."
+    os.system("ctags --extra=+f `find -name '*.c'` `find -name '*.h'`")
+
+env.Alias('install', [install_dir, man_dir, cfg_dir])

=== debian/changelog ===
zfs-fuse (0.6.9-1) unstable; urgency=low

  * New upstream release.

  [ Mike Hommey ]
  * debian/control:
    - Build depend on libssl-dev and libattr1-dev, now required to build.
    - Build depend on docbook-xml to avoid xsltproc I/O error loading
      docbook DTD.
    - Add suggestions for a NFS server and kpartx.
  * debian/man/*, debian/copyright, debian/rules: Remove manual pages, they
    are now shipped upstream.
  * debian/copyright: Change download link.
  * src/SConstruct:
    - Add an optim option to the build system.
    - Add support for DESTDIR.
    - Force debug=1 to mean optim, no strip, no debug.
    - Use -ffunction-sections, -fdata-sections, and --gc-sections flags to
      reduce the binary sizes.
  * src/lib/libumem/SConscript: Cleanup src/lib/libumem when cleaning up
    build directory.
  * src/cmd/*/SConscript: Don't link zfs, zpool and zdb against libssl.
  * src/lib/libumem/SConscript: Only build static libumem.
  * src/lib/libumem/sol_compat.h:
    - Add atomic cas support for sparc.
    - Use atomic functions from libsolcompat in libumem on unsupported
      platforms.
  * debian/rules:
    - Set optimization level in build system according to DEB_BUILD_OPTIONS.
    - Build with debug=1 to have unstripped binaries ; dh_strip will do the
      right thing.
    - Don't depend on the local location of the docbook XSLT stylesheets.
      Use the catalogged url in place of the full path.
    - Don't clean src/.sconsign.dblite and src/path.pyc.
    - Set all destination directories when installing with scons.
    - Install bash completion and zfsrc files.
    - Don't use scons cache when building.
  * debian/prerm: Remove /var/lib/zfs/zpool.cache in prerm.
  * debian/dirs: Create /etc/bash_completion.d.
  * debian/watch: Fix watch file.
  * debian/rules, debian/control, debian/compat: Switch to dh.
  * debian/README.Debian: Update README.Debian.
  * debian/zfs-fuse.man.xml: Update zfs-fuse manual page.
  * debian/zfs-fuse.init: Start sharing datasets marked as such at daemon
    startup.
  * debian/rules, debian/control: Use config.guess and config.sub from
    autotools-dev.

  [ Seth Heeren ]
  * debian/zfs-fuse.man.xml:
    Added notes on the precedence, zfsrc, commandline, initscript vs.
    /etc/default/zfs-fuse on some systems.
  * debian/zfs-fuse.init, debian/zfs-fuse.default: Deprecating DAEMON_OPTS.
  * debian/zfs-fuse.init:
    - Removing import -a -f.
    - Removing the now unnecessary 'sleep 2'.
    - Extended shutdown wait to allow for zfs-fuse daemon's own shutdown
      timeouts.
    - Re-ordered dubious PATH setting.
  * debian/zfs-fuse.init: Move existing zpool.cache to new location if
    possible.

 -- Mike Hommey <glandium@debian.org>  Wed, 30 Jun 2010 18:03:52 +0200

zfs-fuse (0.6.0+critical20100301-5) unstable; urgency=low

  * Silence the init script a bit in case zfs-fuse was disabled
    (Closes: #581668).

 -- Sebastien Delafond <seb@debian.org>  Thu, 20 May 2010 14:36:06 +0200

zfs-fuse (0.6.0+critical20100301-4) unstable; urgency=low

  * Start the daemon with limits removed and LANG unset, and immunize it
    against the OOM killer, as per
    http://rudd-o.com/en/linux-and-free-software/starting-zfs-fuse-up-properly.

 -- Sebastien Delafond <seb@debian.org>  Wed, 12 May 2010 12:53:09 +0200

zfs-fuse (0.6.0+critical20100301-3) unstable; urgency=low

  * Disable debug mode, per http://zfs-fuse.net/issues/33 (LP: #538847).

 -- Sebastien Delafond <seb@debian.org>  Tue, 27 Apr 2010 13:59:45 +0200

zfs-fuse (0.6.0+critical20100301-2) unstable; urgency=low

  * Updated Homepage: field, and removed incorrect Vcs-*: info, from
    control file.
  * Moved to quilt (3.0) source format.

 -- Sebastien Delafond <seb@debian.org>  Thu, 08 Apr 2010 13:00:04 +0200

zfs-fuse (0.6.0+critical20100301-1) unstable; urgency=low

  * Build from the official/critical branch, which contains several
    important fixes (Closes: #571978).
  
 -- Sebastien Delafond <seb@debian.org>  Mon, 01 Mar 2010 11:34:44 +0100
  

zfs-fuse (0.6.0-2) unstable; urgency=low

  * Added a watch file.
  * Bumped up Standards-Version.
  * Lintian fixes.

 -- Sebastien Delafond <seb@debian.org>  Sun, 21 Feb 2010 18:36:50 +0100

zfs-fuse (0.6.0-1) unstable; urgency=low

  * New upstream release.

 -- Sebastien Delafond <seb@debian.org>  Mon, 18 Jan 2010 14:25:14 +0100

zfs-fuse (0.6.0~beta+433snapshot-4) unstable; urgency=low

  * Versioned build-dep on libfuse-dev >= 2.8.1, since before that libfuse
    didn't set shlibs correctly, per #557143 (Closes: #559970).

 -- Sebastien Delafond <seb@debian.org>  Tue, 08 Dec 2009 09:07:45 +0100

zfs-fuse (0.6.0~beta+433snapshot-3) unstable; urgency=low

  * Start the init.d script a bit later (Closes: #558331).
  * Include a patch that fixes an out-of-memory error (Closes: #559552).
  * Add Mike Hommey <glandium@debian.org> to the list of uploaders.

 -- Sebastien Delafond <seb@debian.org>  Mon, 07 Dec 2009 20:40:16 +0100

zfs-fuse (0.6.0~beta+433snapshot-2) unstable; urgency=low

  * Optimistic Arch:any, waiting for potential FTBFS (#556944).

 -- Sebastien Delafond <seb@debian.org>  Wed, 18 Nov 2009 15:49:42 +0100

zfs-fuse (0.6.0~beta+433snapshot-1) unstable; urgency=low

  * Original release, based on Filip Brcic's (<brcha@gna.org>) work
    (Closes: #419746).
  
 -- Sebastien Delafond <seb@debian.org>  Mon, 26 Oct 2009 16:22:44 +0100

=== debian/control ===
Source: zfs-fuse
Section: otherosfs
Priority: optional
Maintainer: Sebastien Delafond <seb@debian.org>
Uploaders: Mike Hommey <glandium@debian.org>
Build-Depends: debhelper (>= 7.0.50~), scons, libfuse-dev (>= 2.8.1), zlib1g-dev, xsltproc, docbook-xsl, docbook-xml, libaio-dev, libssl-dev, libattr1-dev, autotools-dev
Standards-Version: 3.8.4
Homepage: http://zfs-fuse.net

Package: zfs-fuse
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, fuse-utils, lsb-base
Suggests: nfs-kernel-server, kpartx
Description: ZFS on FUSE
 ZFS is an advanced filesystem from Sun Microsystems, originally developed
 for solaris. It provides a number of advanced features, such as live
 integrity checks, atomic updates, atomic snapshots and clones, compression,
 and much more.
 .
 This package provides an implementation of Sun's ZFS filesystem in userspace,
 using FUSE.

=== debian/rules ===
#!/usr/bin/make -f

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	OPTIM = -O0
else
	OPTIM = -O2
endif

override_dh_auto_build:
	scons --no-cache -C src debug=1 optim=$(OPTIM)
	xsltproc --nonet http://docbook.sourceforge.net/release/xsl/current/manpages/docbook.xsl debian/zfs-fuse.man.xml

override_dh_auto_clean:
	scons -c -C src
	rm -f zfs-fuse.8
	-test -r /usr/share/misc/config.sub && \
	cp -f /usr/share/misc/config.sub src/lib/libumem/config.sub
	-test -r /usr/share/misc/config.guess && \
	cp -f /usr/share/misc/config.guess src/lib/libumem/config.guess


override_dh_auto_install:
	scons -C src debug=1 DESTDIR=$(CURDIR)/debian/zfs-fuse install_dir=/sbin man_dir=/usr/share/man/man8 install
	install -m 644 contrib/zfsrc $(CURDIR)/debian/zfs-fuse/etc/zfs
	install -m 644 -T contrib/zfs_completion.bash $(CURDIR)/debian/zfs-fuse/etc/bash_completion.d/zfs-fuse

override_dh_installchangelogs:
	dh_installchangelogs CHANGES

override_dh_installinit:
	dh_installinit --no-start -- start 38 S . stop 39 0 6 .

override_dh_installman:
	dh_installman zfs-fuse.8

%:
	dh $@

## zfs-fuse 0.7.0

=== Makefile ===
all:
	./update-programs.py
	./collect-libs.py

initrd.gz: all
	./gen-image-from-to source initrd.gz

clean:
	./clean-libraries
	./clean-programs.py
	rm initrd.gz

=== wscript ===
--- 
+++ 
@@ -32,7 +32,7 @@
 
 
 APPNAME = 'zfs-fuse'
-VERSION = '0.6.9'
+VERSION = '0.7.0'
 
 srcdir = '.'
 blddir = '__build'
@@ -61,11 +61,12 @@
 ####
 def set_options(opt):
     opt.add_option('--prefix', type='string',help='set install path prefix', dest='usr_prefix')
+    opt.add_option('--build', action='store', default='debug,release', help='Choose \'debug/release/debug,release\'')
 
 
 def init(ctx):
     import Configure
-#    Configure.configure.define('_FILE_OFFSET_BITS', 64)
+
 ####
 #Configuration
 ####
@@ -79,7 +80,8 @@
 
 
 #    conf.env.CCFLAGS = ['-Wall']
-    conf.env.CCFLAGS = ['-pipe', '-Wall', '-std=c99', '-Wno-switch', '-Wno-unused', '-Wno-missing-braces', '-Wno-parentheses', '-Wno-uninitialized', '-fno-strict-aliasing', '-D_GNU_SOURCE', '-DLINUX_AIO']
+    conf.env.ASFLAGS = ["-c"]
+    conf.env.CCFLAGS = ['-pipe', '-Wall', '-std=gnu99', '-Wno-switch', '-Wno-unused', '-Wno-missing-braces', '-Wno-parentheses', '-Wno-uninitialized', '-fno-strict-aliasing', '-D_GNU_SOURCE', '-DLINUX_AIO']
     conf.env.INCLUDEDIR = ['/usr/include/']
 #    conf.env['INCLUDEDIR'] = '/usr/include'
 #    conf.define('_FILE_OFFSET_BITS', 64) 
@@ -96,30 +98,18 @@
     conf.check_cc(lib='m',  uselib_store='m_lib',  mandatory=True)
     conf.check_cc(header_name='fuse/fuse_lowlevel.h', includes=['/usr/include/'], 
             ccflags='-D_FILE_OFFSET_BITS=64', uselib_store='fuse_defines', mandatory=True)
-#    conf.check_cc(header_name='attr/xattr.h', includes=['/usr/include/'], mandatory=True) # FIXME not working properly
+    conf.check(
+        		fragment='#include <sys/types.h>\n #include <attr/xattr.h>\nint main() { return 0; }\n',
+        		define_name='xattr_defines',
+        		execute=1,
+        		define_ret=1,
+            mandatory=True,
+        		msg='Checking for <attr/xattr.h>')
     conf.check_cc(lib='rt', uselib_store='rt_lib', mandatory=True)
     conf.check_tool('gas')
     #if not conf.env.AS: conf.env.AS = conf.env.CC
     conf.env.AS = conf.env.CC
 
-#    try:
-#		conf.check_cc(compile_filename='test.s', fragment='''
-#.text
-#.align 2
-#
-#val:
-# .long 10
-#
-## Multiply input value by 10...
-#.global mult10
-#.type mult10, function
-#mult10:
-#  movl val,%eax
-#  imul 4(%esp),%eax
-#  ret
-#	''', type='cstaticlib', mandatory=True, msg='Checking for assembler')
-#    except:
-#		conf.env.AS = None
 
     ###################### install configuration ################
 
@@ -127,8 +117,25 @@
     warn(" setting MANDIR = %s" % conf.env.MANDIR)
     conf.env.PREFIX = '/'
     conf.env.MANDIR = '/usr/share/man/man8'
+    
+    dbg = conf.env.copy()
+    rel = conf.env.copy()
 
+    dbg.set_variant('debug')
+    conf.set_env_name('debug', dbg)
+    conf.setenv('debug')
+    #sss - this is a hack. dunno why ASFLAGS dont propagate. maybe a bug
+    conf.env.ASFLAGS='-c'
+    conf.env.CCFLAGS += ['-DDBG_ENABLED']
+    
+    rel.set_variant('release')
+    conf.set_env_name('release', rel)
+    conf.setenv('release')
+    #sss - this is a hack. dunno why ASFLAGS dont propagate. maybe a bug
+    conf.env.ASFLAGS='-c'
+    conf.env.CCFLAGS += ['-O2']
 
+    conf.sub_config("src/lib/libumem")
 ####
 #Build
 ####
@@ -138,3 +145,18 @@
     #man_list = bld.path.ant_glob('doc/*.gz')
     bld.install_files('${MANDIR}', 'doc/*.gz')
     
+    # enable the debug or the release variant, depending on the one wanted
+    for obj in bld.all_task_gen[:]:
+      debug_obj = obj.clone('debug')
+      release_obj = obj.clone('release')
+
+      #disable "default"
+      obj.posted = 1
+
+
+      # disable the unwanted variant(s)
+      build_type = Options.options.build
+      if build_type.find('debug') < 0:
+        debug_obj.posted = 1
+      if build_type.find('release') < 0:
+        release_obj.posted = 1

=== doc/Makefile ===
PAGES=zfs zfs-fuse zdb zstreamdump zpool
XSLTPROC=$()

all: $(PAGES:=.8)

%.8.gz: %.8
	cat "$<" | gzip > "$@"

%.8: %.man.xml
	@if [ -z "$(shell which xsltproc)" ]; then echo "Cannot find xsltproc"; fi
	xsltproc -o "$@" --nonet http://docbook.sourceforge.net/release/xsl/current/manpages/docbook.xsl "$<" || \
		echo "Cannot build manpage. Dependencies on debian: apt-get install xsltproc docbook-xsl docbook-xml"

=== src/SConstruct ===
--- 
+++ 
@@ -1,13 +1,27 @@
+# vim: noexpandtab ft=python
 import os, sys, re
 
 # Accepted parameters (and defaults):
 #
 #   install_dir=/usr/local/sbin - directory where the install target copies the binaries
-#   debug=1 - compilation style: 0 = optimize and strip, 1 = optimize with debug info, 2 = debug info, 3 = instrument functions
+#   debug=0 - compilation style: 0 = optimize and strip, 1 = optimize with debug info, 2 = debug info, 3 = instrument functions
+#   optim="-pipe -O2 -march=native" to override the optimization flags (useful when building debug=1 for packaging)
 
-install_dir = ARGUMENTS.get('install_dir', '/usr/local/sbin')
-man_dir = ARGUMENTS.get('man_dir', '/usr/local/share/man/man8/')
-cfg_dir = ARGUMENTS.get('cfg_dir', '/etc/zfs')
+DESTDIR = ARGUMENTS.get('DESTDIR')
+
+def arg_get(name, default):
+	global DESTDIR
+	arg = ARGUMENTS.get(name, default)
+	if DESTDIR:
+		if os.path.isabs(arg):
+			arg = '.' + arg
+		return os.path.join(DESTDIR, arg)
+	else:
+		return arg
+
+install_dir = arg_get('install_dir', '/usr/local/sbin')
+man_dir     = arg_get('man_dir',     '/usr/local/share/man/man8/')
+cfg_dir     = arg_get('cfg_dir',     '/etc/zfs')
 
 env = Environment()
 
@@ -24,20 +38,27 @@
   env.Append(CPPFLAGS = " -DLINUX_AIO")
 
 debug = int(ARGUMENTS.get('debug', '0'))
+optim = ARGUMENTS.get('optim', '-O2')
 
 if not debug:
 	env.Append(LINKFLAGS = ['-s'])
-	env.Append(CCFLAGS = Split('-s -O2 -DNDEBUG'))
+	env.Append(CCFLAGS = Split(" ".join(["-s -DNDEBUG", optim])));
 else:
 	env.Append(LINKFLAGS = ['-ggdb'])
 	env.Append(CCFLAGS = ['-ggdb'])
 # Be careful here, one of DEBUG or NDEBUG must be defined, if you undef both, you'll get unexpected results
 	if debug == 1:
-		env.Append(CCFLAGS = Split('-O2 -DDEBUG'))
+		env.Append(CCFLAGS = Split(" ".join(["-DNDEBUG", optim])));
 	elif debug == 2:
 		env.Append(CCFLAGS = ['-DDEBUG'])
 	elif debug == 3:
 		env.Append(CCFLAGS = Split('-finstrument-functions -DDEBUG'))
+
+if not (('-DDEBUG' in env['CCFLAGS']) or 
+		('-DNDEBUG' in env['CCFLAGS'])):
+	print
+	print "Misconfigured debug level: Neither DEBUG or NDEBUG appears to have been defined: %s" % env['CCFLAGS']
+	sys.exit(1)
 
 env['CPPPATH'] = []
 
@@ -101,10 +122,11 @@
 env.Install(install_dir, 'cmd/zstreamdump/zstreamdump')
 env.Install(cfg_dir, '../contrib/zfs_pool_alert')
 
-env.Install(man_dir, '../doc/zdb.8.gz')
-env.Install(man_dir, '../doc/zfs.8.gz')
-env.Install(man_dir, '../doc/zpool.8.gz')
-env.Install(man_dir, '../doc/zstreamdump.8.gz')
+env.Install(man_dir, '../doc/zdb.8')
+env.Install(man_dir, '../doc/zfs.8')
+env.Install(man_dir, '../doc/zpool.8')
+env.Install(man_dir, '../doc/zstreamdump.8')
+env.Install(man_dir, '../doc/zfs-fuse.8')
 
 if "tags" in sys.argv:
     print "updating tags..."

=== debian/changelog ===
zfs-fuse (0.7.0-33) unstable; urgency=medium

  [ Aron Xu ]
  * QA upload.
  * d/patches: support arm64 rv64 loong64 with generic atomics
  * d/control: set to build on arch:any
  * d/rules: respect DEB_BUILD_OPTIONS=parallel=<n>
  * d/patches: add generic ec_atomic_cas to libumem with GCC built-in
  * d/patches: use recommended buildflags
  * d/patches: fix format security issues

  [ Shengqi Chen ]
  * Add patch to fix arm64 compilation errors

 -- Aron Xu <aron@debian.org>  Fri, 19 Dec 2025 01:51:54 +0800

zfs-fuse (0.7.0-32) unstable; urgency=medium

  * QA upload.
  * d/patches: port to fuse3 (Closes: #1084485)
  * d/control: b-d on libfuse3-dev
  * d/control: add conflicts/breaks to zfsutils-linux

 -- Aron Xu <aron@debian.org>  Tue, 02 Dec 2025 20:53:29 +0800

zfs-fuse (0.7.0-31) unstable; urgency=medium

  * QA upload.
  * d/control: depends on fuse3 (Closes: #1084485)

 -- Aron Xu <aron@debian.org>  Sat, 15 Nov 2025 17:24:30 +0800

zfs-fuse (0.7.0-30) unstable; urgency=medium

  * QA upload.
  * Remove the double .a to allow compilation (Closes: #1084391)

 -- Aron Xu <aron@debian.org>  Fri, 18 Oct 2024 11:48:00 +0800

zfs-fuse (0.7.0-29) unstable; urgency=medium

  * QA upload.
  * Add patch to use sys/xattr.h instead of xattr/xattr.h (Closes: #953938)

 -- Hilko Bengen <bengen@debian.org>  Thu, 05 Sep 2024 15:19:32 +0200

zfs-fuse (0.7.0-28) unstable; urgency=medium

  * QA upload.
  * Add patch to FTBFS with gcc-14. (Closes: #1075705)

 -- Michael Jeanson <mjeanson@debian.org>  Thu, 08 Aug 2024 16:18:50 -0400

zfs-fuse (0.7.0-27) unstable; urgency=medium

  * QA upload.
  * Add libtirpc-dev build-dependency.  (Closes: #1065185)
  * Set Rules-Requires-Root: no.
  * Bump debhelper-compat to 13.
  * Do not reinvent dh_update_autotools_config etc.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 05 Mar 2024 12:23:25 +0100

zfs-fuse (0.7.0-26) unstable; urgency=medium

  * QA upload.
  * Install into /usr (DEP17 M2)

 -- Chris Hofstaedtler <zeha@debian.org>  Tue, 09 Jan 2024 22:15:54 +0100

zfs-fuse (0.7.0-25) unstable; urgency=medium

  * QA upload.

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster (oldstable):
    + Build-Depends: Drop versioned constraint on libfuse-dev.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Wed, 02 Nov 2022 21:56:35 +0000

zfs-fuse (0.7.0-24) unstable; urgency=medium

  * QA upload.

  * Remove debian/watch, mentions of zfs-fuse.net (Closes: #1013948)

 -- Hilko Bengen <bengen@debian.org>  Thu, 22 Sep 2022 14:02:56 +0200

zfs-fuse (0.7.0-23) unstable; urgency=medium

  * QA upload.

  [ Hilko Bengen ]
  * Add patch to FTBFS with glibc >= 2..34 (Closes: #1017162, #1017311)

 -- Hilko Bengen <bengen@debian.org>  Thu, 22 Sep 2022 01:32:45 +0200

zfs-fuse (0.7.0-22) unstable; urgency=medium

  * QA upload.

  [ Debian Janitor ]
  * Remove constraints unnecessary since stretch:
    + zfs-fuse: Drop versioned constraint on fuse in Depends.

  [ Aurelien Jarno ]
  * Add glibc-2.32-compat.patch to switch from glibc's legacy RPC
    implementation, which is now disabled in the Debian package, to libtirpc's
    one (Closes: #971688).

 -- Aurelien Jarno <aurel32@debian.org>  Sat, 21 Aug 2021 19:44:09 +0200

zfs-fuse (0.7.0-21) unstable; urgency=medium

  * QA upload.

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Bump debhelper from old 10 to 12.
  * Set debhelper-compat version in Build-Depends.

  [ Hilko Bengen ]
  * Add patches to deal with GCC10-related FTBFS (Closes: #958013)

 -- Hilko Bengen <bengen@debian.org>  Mon, 31 Aug 2020 21:06:22 +0200

zfs-fuse (0.7.0-20) unstable; urgency=medium

  * QA upload.
  * Add patch from Phil Wyett to fix build with Python3 scons.  Closes: #947588

 -- Mattia Rizzolo <mattia@debian.org>  Sat, 04 Jan 2020 16:38:32 +0100

zfs-fuse (0.7.0-19) unstable; urgency=medium

  * QA upload.
  * Migrate Git repository to Salsa, fix VCS headers
  * Add several missing #include statements that lead to build failures
    with glibc 2.28 (Closes: #916019)

 -- Hilko Bengen <bengen@debian.org>  Mon, 17 Dec 2018 17:48:52 +0100

zfs-fuse (0.7.0-18) unstable; urgency=medium

  * QA upload.
  * zfs-fuse.service: Relax ordering requirements (Closes: #877505)
  * Remove unneeded build-dependencies: autotools-dev, dh-systemd

 -- Hilko Bengen <bengen@debian.org>  Sun, 29 Oct 2017 18:44:29 +0100

zfs-fuse (0.7.0-17) unstable; urgency=medium

  * QA upload.
  * debian/control: Add sparc64 to Architectures
  * debian/sparc64.patch: New patch to fix build on sparc64.

 -- James Clarke <jrtc27@debian.org>  Sun, 09 Jul 2017 00:40:24 +0100

zfs-fuse (0.7.0-16) unstable; urgency=medium

  * debian/control: removed mips64el and m68k from Build-Depends field.

 -- Allan Dixon Jr. <allandixonjr@gmail.com>  Tue, 29 Nov 2016 09:22:37 -0500

zfs-fuse (0.7.0-15) unstable; urgency=medium

  * QA upload.
  * Upload to unstable.
  * Architectures: after a build in experimental:
      - Keep amd64,armel,i386,powerpc,sparc.
      - Add armhf,powerpcspe,ppc64,ppc64el. (Closes: #731650)
      - Try m68k,mips64el,sh4 not processed by experimental.

 -- Allan Dixon Jr. <allandixonjr@gmail.com>  Tue, 08 Nov 2016 14:16:13 -0500

zfs-fuse (0.7.0-14) experimental; urgency=medium

  * QA upload.
  * Set Debian QA Group as maintainer. (see #834130)
  * Ack for previous NMU.
  * Bump DH level to 10.
  * Bump Standards-Version to 3.9.8.
  * Change architecture to any. (it may solve #731650)
  * Run wrap-and-sort.
  * Use https in Vcs-*.

 -- Allan Dixon Jr. <allandixonjr@gmail.com>  Wed, 26 Oct 2016 10:50:29 -0500

zfs-fuse (0.7.0-13.1) unstable; urgency=medium

  * Non-maintainer upload with maintainer approval.
  * Add debian/zfs-fuse.service (Closes: #796705)
    - this is a simple wrapper around the init script with room for
      improvement. Mostly copied from the by systemd-sysv-generator
      autogenerated unit with minor modifications. Future work would be
      to split out the program parts of the init script


=== debian/control ===
Source: zfs-fuse
Section: otherosfs
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: debhelper-compat (= 13),
               libaio-dev,
               libattr1-dev,
               libfuse3-dev,
               libssl-dev,
               libtirpc-dev,
               scons,
               zlib1g-dev
Rules-Requires-Root: no
Standards-Version: 3.9.8
Vcs-Git: https://salsa.debian.org/debian/zfs-fuse.git
Vcs-Browser: https://salsa.debian.org/debian/zfs-fuse

Package: zfs-fuse
Architecture: any
Depends:
 fuse3 (>= 3.10.1-3),
 ${misc:Depends},
 ${shlibs:Depends}
Conflicts: zfsutils-linux
Breaks: zfsutils-linux
Suggests: kpartx, nfs-kernel-server
Description: ZFS on FUSE
 ZFS is an advanced filesystem from Sun Microsystems, originally developed
 for solaris. It provides a number of advanced features, such as live
 integrity checks, atomic updates, atomic snapshots and clones, compression,
 and much more.
 .
 This package provides an implementation of Sun's ZFS filesystem in userspace,
 using FUSE.

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/buildflags.mk

SCONSFLAGS=--no-cache -C src debug=1

ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
	SCONSFLAGS += -j $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

SCONSFLAGS += env_cflags="${CFLAGS}" env_cppflags="${CPPFLAGS}" env_ldflags="${LDFLAGS}"

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	SCONSFLAGS+= optim=-O0
else
	SCONSFLAGS+= optim=-O2
endif

override_dh_auto_build:
	scons $(SCONSFLAGS)

override_dh_auto_clean:
	scons $(SCONSFLAGS) -ccc
	rm -f src/.sconsign.dblite

override_dh_auto_install:
	scons $(SCONSFLAGS) DESTDIR=$(CURDIR)/debian/zfs-fuse install_dir=/usr/sbin man_dir=/usr/share/man/man8 install
	install -m 644 contrib/zfsrc $(CURDIR)/debian/zfs-fuse/etc/zfs
	install -m 644 -T contrib/zfs_completion.bash $(CURDIR)/debian/zfs-fuse/usr/share/bash-completion/completions/zfs-fuse
	rm -f debian/zfs-fuse/usr/sbin/ztest

override_dh_installchangelogs:
	dh_installchangelogs CHANGES

override_dh_installinit:
	dh_installinit --no-start -- start 38 S . stop 39 0 6 .

%:
	dh $@
